<html>
<head>
<title>OgreD3D9Resource.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_c7ffc14721c8bed1493f4f78ca8c7331.html">Direct3D9</a>      </li>
      <li class="navelem"><a class="el" href="dir_1208738e8444befc5f502320df40a1ea.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D9Resource.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D9Resource_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D9Resource_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D9Resource_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Prerequisites_8h.html">OgreD3D9Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 
<a name="l00039"></a><a class="code" href="classOgre_1_1D3D9Resource.html">00039</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource.">D3D9Resource</a>
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042     <span class="comment">// Interface.</span>
<a name="l00043"></a>00043     <span class="keyword">public</span>:
<a name="l00044"></a>00044 
<a name="l00045"></a>00045         <span class="comment">// Called immediately after the Direct3D device has been created.</span>
<a name="l00046"></a><a class="code" href="classOgre_1_1D3D9Resource.html#ac2b865b0cd4754552c38fd6c6f83064f">00046</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9Resource.html#ac2b865b0cd4754552c38fd6c6f83064f">notifyOnDeviceCreate</a>(IDirect3DDevice9* d3d9Device) {}
<a name="l00047"></a>00047 
<a name="l00048"></a>00048         <span class="comment">// Called before the Direct3D device is going to be destroyed.</span>
<a name="l00049"></a><a class="code" href="classOgre_1_1D3D9Resource.html#a1ceaf6c7f17b55a2dfb818360bb8a97b">00049</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9Resource.html#a1ceaf6c7f17b55a2dfb818360bb8a97b">notifyOnDeviceDestroy</a>(IDirect3DDevice9* d3d9Device) {}
<a name="l00050"></a>00050 
<a name="l00051"></a>00051         <span class="comment">// Called immediately after the Direct3D device has entered a lost state.</span>
<a name="l00052"></a>00052         <span class="comment">// This is the place to release non-managed resources.</span>
<a name="l00053"></a><a class="code" href="classOgre_1_1D3D9Resource.html#a8d55f1d5ce61a1b796d8d86dd3c69fdb">00053</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9Resource.html#a8d55f1d5ce61a1b796d8d86dd3c69fdb">notifyOnDeviceLost</a>(IDirect3DDevice9* d3d9Device) {}
<a name="l00054"></a>00054 
<a name="l00055"></a>00055         <span class="comment">// Called immediately after the Direct3D device has been reset.</span>
<a name="l00056"></a>00056         <span class="comment">// This is the place to create non-managed resources.</span>
<a name="l00057"></a><a class="code" href="classOgre_1_1D3D9Resource.html#a9008da922e8b8762ac284cc1f08a0749">00057</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D9Resource.html#a9008da922e8b8762ac284cc1f08a0749">notifyOnDeviceReset</a>(IDirect3DDevice9* d3d9Device) {}
<a name="l00058"></a>00058 
<a name="l00059"></a>00059         <span class="comment">// Called when device state is changing. Access to any device should be locked.</span>
<a name="l00060"></a>00060         <span class="comment">// Relevant for multi thread application.</span>
<a name="l00061"></a>00061         <span class="keyword">static</span> <span class="keywordtype">void</span> lockDeviceAccess();
<a name="l00062"></a>00062 
<a name="l00063"></a>00063         <span class="comment">// Called when device state change completed. Access to any device is allowed.</span>
<a name="l00064"></a>00064         <span class="comment">// Relevant for multi thread application.</span>
<a name="l00065"></a>00065         <span class="keyword">static</span> <span class="keywordtype">void</span> unlockDeviceAccess();
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keyword">public</span>:
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource.">D3D9Resource</a>            ();
<a name="l00070"></a>00070         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource.">D3D9Resource</a>   ();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     <span class="keyword">protected</span>:
<a name="l00073"></a>00073         <a class="code" href="OgrePrerequisites_8h.html#ac853de57688aefaec88f75cd9e0ac388">OGRE_STATIC_MUTEX</a>(msDeviceAccessMutex)      
<a name="l00074"></a>00074     };
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
